import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAzurermManagedApiConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/data-sources/managed_api#id DataAzurermManagedApi#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/data-sources/managed_api#location DataAzurermManagedApi#location}
    */
    readonly location: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/data-sources/managed_api#name DataAzurermManagedApi#name}
    */
    readonly name: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/data-sources/managed_api#timeouts DataAzurermManagedApi#timeouts}
    */
    readonly timeouts?: DataAzurermManagedApiTimeouts;
}
export interface DataAzurermManagedApiTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/data-sources/managed_api#read DataAzurermManagedApi#read}
    */
    readonly read?: string;
}
export declare function dataAzurermManagedApiTimeoutsToTerraform(struct?: DataAzurermManagedApiTimeouts | cdktf.IResolvable): any;
export declare class DataAzurermManagedApiTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAzurermManagedApiTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataAzurermManagedApiTimeouts | cdktf.IResolvable | undefined);
    private _read?;
    get read(): string;
    set read(value: string);
    resetRead(): void;
    get readInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/data-sources/managed_api azurerm_managed_api}
*/
export declare class DataAzurermManagedApi extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "azurerm_managed_api";
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/data-sources/managed_api azurerm_managed_api} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAzurermManagedApiConfig
    */
    constructor(scope: Construct, id: string, config: DataAzurermManagedApiConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _location?;
    get location(): string;
    set location(value: string);
    get locationInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _tags;
    get tags(): cdktf.StringMap;
    private _timeouts;
    get timeouts(): DataAzurermManagedApiTimeoutsOutputReference;
    putTimeouts(value: DataAzurermManagedApiTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataAzurermManagedApiTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
