import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ServiceFabricManagedClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#backup_service_enabled ServiceFabricManagedCluster#backup_service_enabled}
    */
    readonly backupServiceEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#client_connection_port ServiceFabricManagedCluster#client_connection_port}
    */
    readonly clientConnectionPort: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#dns_name ServiceFabricManagedCluster#dns_name}
    */
    readonly dnsName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#dns_service_enabled ServiceFabricManagedCluster#dns_service_enabled}
    */
    readonly dnsServiceEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#http_gateway_port ServiceFabricManagedCluster#http_gateway_port}
    */
    readonly httpGatewayPort: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#id ServiceFabricManagedCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#location ServiceFabricManagedCluster#location}
    */
    readonly location: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#name ServiceFabricManagedCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#password ServiceFabricManagedCluster#password}
    */
    readonly password?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#resource_group_name ServiceFabricManagedCluster#resource_group_name}
    */
    readonly resourceGroupName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#sku ServiceFabricManagedCluster#sku}
    */
    readonly sku?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#tags ServiceFabricManagedCluster#tags}
    */
    readonly tags?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#upgrade_wave ServiceFabricManagedCluster#upgrade_wave}
    */
    readonly upgradeWave?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#username ServiceFabricManagedCluster#username}
    */
    readonly username?: string;
    /**
    * authentication block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#authentication ServiceFabricManagedCluster#authentication}
    */
    readonly authentication?: ServiceFabricManagedClusterAuthentication;
    /**
    * custom_fabric_setting block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#custom_fabric_setting ServiceFabricManagedCluster#custom_fabric_setting}
    */
    readonly customFabricSetting?: ServiceFabricManagedClusterCustomFabricSetting[] | cdktf.IResolvable;
    /**
    * lb_rule block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#lb_rule ServiceFabricManagedCluster#lb_rule}
    */
    readonly lbRule: ServiceFabricManagedClusterLbRule[] | cdktf.IResolvable;
    /**
    * node_type block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#node_type ServiceFabricManagedCluster#node_type}
    */
    readonly nodeType?: ServiceFabricManagedClusterNodeType[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#timeouts ServiceFabricManagedCluster#timeouts}
    */
    readonly timeouts?: ServiceFabricManagedClusterTimeouts;
}
export interface ServiceFabricManagedClusterAuthenticationActiveDirectory {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#client_application_id ServiceFabricManagedCluster#client_application_id}
    */
    readonly clientApplicationId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#cluster_application_id ServiceFabricManagedCluster#cluster_application_id}
    */
    readonly clusterApplicationId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#tenant_id ServiceFabricManagedCluster#tenant_id}
    */
    readonly tenantId: string;
}
export declare function serviceFabricManagedClusterAuthenticationActiveDirectoryToTerraform(struct?: ServiceFabricManagedClusterAuthenticationActiveDirectoryOutputReference | ServiceFabricManagedClusterAuthenticationActiveDirectory): any;
export declare class ServiceFabricManagedClusterAuthenticationActiveDirectoryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ServiceFabricManagedClusterAuthenticationActiveDirectory | undefined;
    set internalValue(value: ServiceFabricManagedClusterAuthenticationActiveDirectory | undefined);
    private _clientApplicationId?;
    get clientApplicationId(): string;
    set clientApplicationId(value: string);
    get clientApplicationIdInput(): string | undefined;
    private _clusterApplicationId?;
    get clusterApplicationId(): string;
    set clusterApplicationId(value: string);
    get clusterApplicationIdInput(): string | undefined;
    private _tenantId?;
    get tenantId(): string;
    set tenantId(value: string);
    get tenantIdInput(): string | undefined;
}
export interface ServiceFabricManagedClusterAuthenticationCertificate {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#common_name ServiceFabricManagedCluster#common_name}
    */
    readonly commonName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#thumbprint ServiceFabricManagedCluster#thumbprint}
    */
    readonly thumbprint: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#type ServiceFabricManagedCluster#type}
    */
    readonly type: string;
}
export declare function serviceFabricManagedClusterAuthenticationCertificateToTerraform(struct?: ServiceFabricManagedClusterAuthenticationCertificate | cdktf.IResolvable): any;
export declare class ServiceFabricManagedClusterAuthenticationCertificateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ServiceFabricManagedClusterAuthenticationCertificate | cdktf.IResolvable | undefined;
    set internalValue(value: ServiceFabricManagedClusterAuthenticationCertificate | cdktf.IResolvable | undefined);
    private _commonName?;
    get commonName(): string;
    set commonName(value: string);
    resetCommonName(): void;
    get commonNameInput(): string | undefined;
    private _thumbprint?;
    get thumbprint(): string;
    set thumbprint(value: string);
    get thumbprintInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class ServiceFabricManagedClusterAuthenticationCertificateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ServiceFabricManagedClusterAuthenticationCertificate[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ServiceFabricManagedClusterAuthenticationCertificateOutputReference;
}
export interface ServiceFabricManagedClusterAuthentication {
    /**
    * active_directory block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#active_directory ServiceFabricManagedCluster#active_directory}
    */
    readonly activeDirectory?: ServiceFabricManagedClusterAuthenticationActiveDirectory;
    /**
    * certificate block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#certificate ServiceFabricManagedCluster#certificate}
    */
    readonly certificate?: ServiceFabricManagedClusterAuthenticationCertificate[] | cdktf.IResolvable;
}
export declare function serviceFabricManagedClusterAuthenticationToTerraform(struct?: ServiceFabricManagedClusterAuthenticationOutputReference | ServiceFabricManagedClusterAuthentication): any;
export declare class ServiceFabricManagedClusterAuthenticationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ServiceFabricManagedClusterAuthentication | undefined;
    set internalValue(value: ServiceFabricManagedClusterAuthentication | undefined);
    private _activeDirectory;
    get activeDirectory(): ServiceFabricManagedClusterAuthenticationActiveDirectoryOutputReference;
    putActiveDirectory(value: ServiceFabricManagedClusterAuthenticationActiveDirectory): void;
    resetActiveDirectory(): void;
    get activeDirectoryInput(): ServiceFabricManagedClusterAuthenticationActiveDirectory | undefined;
    private _certificate;
    get certificate(): ServiceFabricManagedClusterAuthenticationCertificateList;
    putCertificate(value: ServiceFabricManagedClusterAuthenticationCertificate[] | cdktf.IResolvable): void;
    resetCertificate(): void;
    get certificateInput(): cdktf.IResolvable | ServiceFabricManagedClusterAuthenticationCertificate[] | undefined;
}
export interface ServiceFabricManagedClusterCustomFabricSetting {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#parameter ServiceFabricManagedCluster#parameter}
    */
    readonly parameter: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#section ServiceFabricManagedCluster#section}
    */
    readonly section: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#value ServiceFabricManagedCluster#value}
    */
    readonly value: string;
}
export declare function serviceFabricManagedClusterCustomFabricSettingToTerraform(struct?: ServiceFabricManagedClusterCustomFabricSetting | cdktf.IResolvable): any;
export declare class ServiceFabricManagedClusterCustomFabricSettingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ServiceFabricManagedClusterCustomFabricSetting | cdktf.IResolvable | undefined;
    set internalValue(value: ServiceFabricManagedClusterCustomFabricSetting | cdktf.IResolvable | undefined);
    private _parameter?;
    get parameter(): string;
    set parameter(value: string);
    get parameterInput(): string | undefined;
    private _section?;
    get section(): string;
    set section(value: string);
    get sectionInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class ServiceFabricManagedClusterCustomFabricSettingList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ServiceFabricManagedClusterCustomFabricSetting[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ServiceFabricManagedClusterCustomFabricSettingOutputReference;
}
export interface ServiceFabricManagedClusterLbRule {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#backend_port ServiceFabricManagedCluster#backend_port}
    */
    readonly backendPort: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#frontend_port ServiceFabricManagedCluster#frontend_port}
    */
    readonly frontendPort: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#probe_protocol ServiceFabricManagedCluster#probe_protocol}
    */
    readonly probeProtocol: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#probe_request_path ServiceFabricManagedCluster#probe_request_path}
    */
    readonly probeRequestPath?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#protocol ServiceFabricManagedCluster#protocol}
    */
    readonly protocol: string;
}
export declare function serviceFabricManagedClusterLbRuleToTerraform(struct?: ServiceFabricManagedClusterLbRule | cdktf.IResolvable): any;
export declare class ServiceFabricManagedClusterLbRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ServiceFabricManagedClusterLbRule | cdktf.IResolvable | undefined;
    set internalValue(value: ServiceFabricManagedClusterLbRule | cdktf.IResolvable | undefined);
    private _backendPort?;
    get backendPort(): number;
    set backendPort(value: number);
    get backendPortInput(): number | undefined;
    private _frontendPort?;
    get frontendPort(): number;
    set frontendPort(value: number);
    get frontendPortInput(): number | undefined;
    private _probeProtocol?;
    get probeProtocol(): string;
    set probeProtocol(value: string);
    get probeProtocolInput(): string | undefined;
    private _probeRequestPath?;
    get probeRequestPath(): string;
    set probeRequestPath(value: string);
    resetProbeRequestPath(): void;
    get probeRequestPathInput(): string | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    get protocolInput(): string | undefined;
}
export declare class ServiceFabricManagedClusterLbRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ServiceFabricManagedClusterLbRule[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ServiceFabricManagedClusterLbRuleOutputReference;
}
export interface ServiceFabricManagedClusterNodeTypeVmSecretsCertificates {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#store ServiceFabricManagedCluster#store}
    */
    readonly store: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#url ServiceFabricManagedCluster#url}
    */
    readonly url: string;
}
export declare function serviceFabricManagedClusterNodeTypeVmSecretsCertificatesToTerraform(struct?: ServiceFabricManagedClusterNodeTypeVmSecretsCertificates | cdktf.IResolvable): any;
export declare class ServiceFabricManagedClusterNodeTypeVmSecretsCertificatesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ServiceFabricManagedClusterNodeTypeVmSecretsCertificates | cdktf.IResolvable | undefined;
    set internalValue(value: ServiceFabricManagedClusterNodeTypeVmSecretsCertificates | cdktf.IResolvable | undefined);
    private _store?;
    get store(): string;
    set store(value: string);
    get storeInput(): string | undefined;
    private _url?;
    get url(): string;
    set url(value: string);
    get urlInput(): string | undefined;
}
export declare class ServiceFabricManagedClusterNodeTypeVmSecretsCertificatesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ServiceFabricManagedClusterNodeTypeVmSecretsCertificates[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ServiceFabricManagedClusterNodeTypeVmSecretsCertificatesOutputReference;
}
export interface ServiceFabricManagedClusterNodeTypeVmSecrets {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#vault_id ServiceFabricManagedCluster#vault_id}
    */
    readonly vaultId: string;
    /**
    * certificates block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#certificates ServiceFabricManagedCluster#certificates}
    */
    readonly certificates: ServiceFabricManagedClusterNodeTypeVmSecretsCertificates[] | cdktf.IResolvable;
}
export declare function serviceFabricManagedClusterNodeTypeVmSecretsToTerraform(struct?: ServiceFabricManagedClusterNodeTypeVmSecrets | cdktf.IResolvable): any;
export declare class ServiceFabricManagedClusterNodeTypeVmSecretsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ServiceFabricManagedClusterNodeTypeVmSecrets | cdktf.IResolvable | undefined;
    set internalValue(value: ServiceFabricManagedClusterNodeTypeVmSecrets | cdktf.IResolvable | undefined);
    private _vaultId?;
    get vaultId(): string;
    set vaultId(value: string);
    get vaultIdInput(): string | undefined;
    private _certificates;
    get certificates(): ServiceFabricManagedClusterNodeTypeVmSecretsCertificatesList;
    putCertificates(value: ServiceFabricManagedClusterNodeTypeVmSecretsCertificates[] | cdktf.IResolvable): void;
    get certificatesInput(): cdktf.IResolvable | ServiceFabricManagedClusterNodeTypeVmSecretsCertificates[] | undefined;
}
export declare class ServiceFabricManagedClusterNodeTypeVmSecretsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ServiceFabricManagedClusterNodeTypeVmSecrets[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ServiceFabricManagedClusterNodeTypeVmSecretsOutputReference;
}
export interface ServiceFabricManagedClusterNodeType {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#application_port_range ServiceFabricManagedCluster#application_port_range}
    */
    readonly applicationPortRange: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#capacities ServiceFabricManagedCluster#capacities}
    */
    readonly capacities?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#data_disk_size_gb ServiceFabricManagedCluster#data_disk_size_gb}
    */
    readonly dataDiskSizeGb: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#data_disk_type ServiceFabricManagedCluster#data_disk_type}
    */
    readonly dataDiskType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#ephemeral_port_range ServiceFabricManagedCluster#ephemeral_port_range}
    */
    readonly ephemeralPortRange: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#multiple_placement_groups_enabled ServiceFabricManagedCluster#multiple_placement_groups_enabled}
    */
    readonly multiplePlacementGroupsEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#name ServiceFabricManagedCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#placement_properties ServiceFabricManagedCluster#placement_properties}
    */
    readonly placementProperties?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#primary ServiceFabricManagedCluster#primary}
    */
    readonly primary?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#stateless ServiceFabricManagedCluster#stateless}
    */
    readonly stateless?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#vm_image_offer ServiceFabricManagedCluster#vm_image_offer}
    */
    readonly vmImageOffer: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#vm_image_publisher ServiceFabricManagedCluster#vm_image_publisher}
    */
    readonly vmImagePublisher: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#vm_image_sku ServiceFabricManagedCluster#vm_image_sku}
    */
    readonly vmImageSku: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#vm_image_version ServiceFabricManagedCluster#vm_image_version}
    */
    readonly vmImageVersion: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#vm_instance_count ServiceFabricManagedCluster#vm_instance_count}
    */
    readonly vmInstanceCount: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#vm_size ServiceFabricManagedCluster#vm_size}
    */
    readonly vmSize: string;
    /**
    * vm_secrets block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#vm_secrets ServiceFabricManagedCluster#vm_secrets}
    */
    readonly vmSecrets?: ServiceFabricManagedClusterNodeTypeVmSecrets[] | cdktf.IResolvable;
}
export declare function serviceFabricManagedClusterNodeTypeToTerraform(struct?: ServiceFabricManagedClusterNodeType | cdktf.IResolvable): any;
export declare class ServiceFabricManagedClusterNodeTypeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ServiceFabricManagedClusterNodeType | cdktf.IResolvable | undefined;
    set internalValue(value: ServiceFabricManagedClusterNodeType | cdktf.IResolvable | undefined);
    private _applicationPortRange?;
    get applicationPortRange(): string;
    set applicationPortRange(value: string);
    get applicationPortRangeInput(): string | undefined;
    private _capacities?;
    get capacities(): {
        [key: string]: string;
    };
    set capacities(value: {
        [key: string]: string;
    });
    resetCapacities(): void;
    get capacitiesInput(): {
        [key: string]: string;
    } | undefined;
    private _dataDiskSizeGb?;
    get dataDiskSizeGb(): number;
    set dataDiskSizeGb(value: number);
    get dataDiskSizeGbInput(): number | undefined;
    private _dataDiskType?;
    get dataDiskType(): string;
    set dataDiskType(value: string);
    resetDataDiskType(): void;
    get dataDiskTypeInput(): string | undefined;
    private _ephemeralPortRange?;
    get ephemeralPortRange(): string;
    set ephemeralPortRange(value: string);
    get ephemeralPortRangeInput(): string | undefined;
    get id(): string;
    private _multiplePlacementGroupsEnabled?;
    get multiplePlacementGroupsEnabled(): boolean | cdktf.IResolvable;
    set multiplePlacementGroupsEnabled(value: boolean | cdktf.IResolvable);
    resetMultiplePlacementGroupsEnabled(): void;
    get multiplePlacementGroupsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _placementProperties?;
    get placementProperties(): {
        [key: string]: string;
    };
    set placementProperties(value: {
        [key: string]: string;
    });
    resetPlacementProperties(): void;
    get placementPropertiesInput(): {
        [key: string]: string;
    } | undefined;
    private _primary?;
    get primary(): boolean | cdktf.IResolvable;
    set primary(value: boolean | cdktf.IResolvable);
    resetPrimary(): void;
    get primaryInput(): boolean | cdktf.IResolvable | undefined;
    private _stateless?;
    get stateless(): boolean | cdktf.IResolvable;
    set stateless(value: boolean | cdktf.IResolvable);
    resetStateless(): void;
    get statelessInput(): boolean | cdktf.IResolvable | undefined;
    private _vmImageOffer?;
    get vmImageOffer(): string;
    set vmImageOffer(value: string);
    get vmImageOfferInput(): string | undefined;
    private _vmImagePublisher?;
    get vmImagePublisher(): string;
    set vmImagePublisher(value: string);
    get vmImagePublisherInput(): string | undefined;
    private _vmImageSku?;
    get vmImageSku(): string;
    set vmImageSku(value: string);
    get vmImageSkuInput(): string | undefined;
    private _vmImageVersion?;
    get vmImageVersion(): string;
    set vmImageVersion(value: string);
    get vmImageVersionInput(): string | undefined;
    private _vmInstanceCount?;
    get vmInstanceCount(): number;
    set vmInstanceCount(value: number);
    get vmInstanceCountInput(): number | undefined;
    private _vmSize?;
    get vmSize(): string;
    set vmSize(value: string);
    get vmSizeInput(): string | undefined;
    private _vmSecrets;
    get vmSecrets(): ServiceFabricManagedClusterNodeTypeVmSecretsList;
    putVmSecrets(value: ServiceFabricManagedClusterNodeTypeVmSecrets[] | cdktf.IResolvable): void;
    resetVmSecrets(): void;
    get vmSecretsInput(): cdktf.IResolvable | ServiceFabricManagedClusterNodeTypeVmSecrets[] | undefined;
}
export declare class ServiceFabricManagedClusterNodeTypeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ServiceFabricManagedClusterNodeType[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ServiceFabricManagedClusterNodeTypeOutputReference;
}
export interface ServiceFabricManagedClusterTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#create ServiceFabricManagedCluster#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#delete ServiceFabricManagedCluster#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#read ServiceFabricManagedCluster#read}
    */
    readonly read?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster#update ServiceFabricManagedCluster#update}
    */
    readonly update?: string;
}
export declare function serviceFabricManagedClusterTimeoutsToTerraform(struct?: ServiceFabricManagedClusterTimeouts | cdktf.IResolvable): any;
export declare class ServiceFabricManagedClusterTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ServiceFabricManagedClusterTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: ServiceFabricManagedClusterTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _read?;
    get read(): string;
    set read(value: string);
    resetRead(): void;
    get readInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster azurerm_service_fabric_managed_cluster}
*/
export declare class ServiceFabricManagedCluster extends cdktf.TerraformResource {
    static readonly tfResourceType = "azurerm_service_fabric_managed_cluster";
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/azurerm/3.54.0/docs/resources/service_fabric_managed_cluster azurerm_service_fabric_managed_cluster} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ServiceFabricManagedClusterConfig
    */
    constructor(scope: Construct, id: string, config: ServiceFabricManagedClusterConfig);
    private _backupServiceEnabled?;
    get backupServiceEnabled(): boolean | cdktf.IResolvable;
    set backupServiceEnabled(value: boolean | cdktf.IResolvable);
    resetBackupServiceEnabled(): void;
    get backupServiceEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _clientConnectionPort?;
    get clientConnectionPort(): number;
    set clientConnectionPort(value: number);
    get clientConnectionPortInput(): number | undefined;
    private _dnsName?;
    get dnsName(): string;
    set dnsName(value: string);
    resetDnsName(): void;
    get dnsNameInput(): string | undefined;
    private _dnsServiceEnabled?;
    get dnsServiceEnabled(): boolean | cdktf.IResolvable;
    set dnsServiceEnabled(value: boolean | cdktf.IResolvable);
    resetDnsServiceEnabled(): void;
    get dnsServiceEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _httpGatewayPort?;
    get httpGatewayPort(): number;
    set httpGatewayPort(value: number);
    get httpGatewayPortInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _location?;
    get location(): string;
    set location(value: string);
    get locationInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _password?;
    get password(): string;
    set password(value: string);
    resetPassword(): void;
    get passwordInput(): string | undefined;
    private _resourceGroupName?;
    get resourceGroupName(): string;
    set resourceGroupName(value: string);
    get resourceGroupNameInput(): string | undefined;
    private _sku?;
    get sku(): string;
    set sku(value: string);
    resetSku(): void;
    get skuInput(): string | undefined;
    private _tags?;
    get tags(): {
        [key: string]: string;
    };
    set tags(value: {
        [key: string]: string;
    });
    resetTags(): void;
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _upgradeWave?;
    get upgradeWave(): string;
    set upgradeWave(value: string);
    resetUpgradeWave(): void;
    get upgradeWaveInput(): string | undefined;
    private _username?;
    get username(): string;
    set username(value: string);
    resetUsername(): void;
    get usernameInput(): string | undefined;
    private _authentication;
    get authentication(): ServiceFabricManagedClusterAuthenticationOutputReference;
    putAuthentication(value: ServiceFabricManagedClusterAuthentication): void;
    resetAuthentication(): void;
    get authenticationInput(): ServiceFabricManagedClusterAuthentication | undefined;
    private _customFabricSetting;
    get customFabricSetting(): ServiceFabricManagedClusterCustomFabricSettingList;
    putCustomFabricSetting(value: ServiceFabricManagedClusterCustomFabricSetting[] | cdktf.IResolvable): void;
    resetCustomFabricSetting(): void;
    get customFabricSettingInput(): cdktf.IResolvable | ServiceFabricManagedClusterCustomFabricSetting[] | undefined;
    private _lbRule;
    get lbRule(): ServiceFabricManagedClusterLbRuleList;
    putLbRule(value: ServiceFabricManagedClusterLbRule[] | cdktf.IResolvable): void;
    get lbRuleInput(): cdktf.IResolvable | ServiceFabricManagedClusterLbRule[] | undefined;
    private _nodeType;
    get nodeType(): ServiceFabricManagedClusterNodeTypeList;
    putNodeType(value: ServiceFabricManagedClusterNodeType[] | cdktf.IResolvable): void;
    resetNodeType(): void;
    get nodeTypeInput(): cdktf.IResolvable | ServiceFabricManagedClusterNodeType[] | undefined;
    private _timeouts;
    get timeouts(): ServiceFabricManagedClusterTimeoutsOutputReference;
    putTimeouts(value: ServiceFabricManagedClusterTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | ServiceFabricManagedClusterTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
